/*
 error_codes.h

 Revised: 2014.08.05
*/

enum
{ /* error codes (mimics MacOS Classic Errors) */
	errSystemResource	=-23,	/* system resource failure */
	errVolumeFull		=-34,	/* writing to a full volume */
	errNoSuchVolume		=-35,
	errSystemIO		=-36,	/* generic I/O error */
	errHitFileEOF		=-39,	/* went past file's end */
	errSeekBadPosition	=-40,	/* tried to position before the logical start */
	errTooManyFiles		=-42,	/* too many files open to open another right now */
	errFileNotFound		=-43,	/* file (or directory) not found */
	errFileIsBusy		=-47,
	errNameCollision	=-48,	/* reserved name, or already one w. same name in directory */
	errFileAlreadyOpen	=-49,
	errParameterError	=-50,
	errBadFileRefError	=-51,	/* no such file ref. (make sure file->function is consistent) */
	errFilePermission	=-54,	/* permission denied for mode - open */
	errFileWriteReadOnly	=-61,	/* attempt to write to a read-only file */
	errOutOfMemory		=-108,	/* not enough memory to complete the operation */
	errNilHandleErr		=-109,	/* Master Pointer was NIL in zone */
	errMemAddrErr		=-110,	/* address was odd or out of range */
	errMemAZErr		=-113,	/* address in zone check failed */
	errMemPCErr		=-114,	/* pointer check failed */
	errMemBCErr		=-115,	/* block check failed */
	errMemSCErr		=-116,	/* size check failed */
	errMemLockedErr		=-117,	/* trying to move (or resize) a locked block */
	errDecompressErr	=-186,	/* load failure - decompressor not found */
	errNoRsrcMapEntry	=-192,	/* load failure - entry doesn't exist */
	errReadBadEntryMap	=-199,	/* entry map is inconsistent or bad for read */
	errWideValue		=-1309	/* invalid file size or position */
};
