/*
 my_cseries.h
  The all-in-one portable include -- faster compilation than using
   Universal Interfaces plus sev. MyCSeries includes
   Dialog code went to myDialogs.

  Created: 2006
  Revised: 2014.08.24

    This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

    This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  for more details.

    You should have received a copy of the GNU General Public License along
  with this program; if not, write to the Free Software Foundation, Inc.,
  59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Sunday, June 24, 2007 5:57:40 PM
A.P.: starting added defines to reroute carbon identifiers under non-carbon.
Monday, June 27, 2011 7:51:27 AM
  now working to *reduce* the need for minimum C source mods.
  stupid me.  can't trust my changes.
*/

#ifndef __MY_CSERIES_H
#if PRAGMA_ONCE
# pragma once
#endif

#define	_style_plain			0
#define	_style_bold			0x1
#define	_style_italic			0x2
#define	_style_underlined		0x4
#define	_style_outlined			0x8
/* these aren't currently implemented */
#define	_style_strike			0x10 /* line-through, at (ascent+leading)/2 */
#define	_style_overlined		0x20
#define	_style_double_underlined	0x40 /* can have 1-3 underlines (all of the above) */
#define	_style_fixed_width		0x80 /* maxWidth for all */
/* yes, justification is stuffed into the 'special' field */
#define _special_align_mask		7
#define _special_align_default		0
#define _special_align_center		1
#define _special_align_left		2 /* force left */
#define _special_align_right		3
#define _special_align_justify		4

#if !defined(rez) && !defined(derez)
 #include "../enviro64.h"
 #include <stdlib.h>

 #ifdef _FCNTL_H
  #include <io.h>
 #elif TARGET_OS_MAC && defined(__FCNTL__)
  #define _open open
  #define _close close
  #define _read read
  #define _write write
  #define _fileno fileno
  #define _lseek lseek
  #define _fdopen fdopen
 #endif

 /* ---- typedefs */

/* the required types defined in MacTypes are defined here;
  no compiler errors should occur if the typedefs/defines completely match
*/

 #define boolean			uint8

/* t_count: meant for rendering, the faster type for values initially 16-bit */
 #if env68k
typedef int16		t_count;
 #else
typedef int32		t_count;
 #endif

typedef int16		ifix16; /* formerly, short_fixed */

typedef uint8		pixel8;
typedef uint16		pixel15, pixel16;
typedef uint32		pixel24, pixel32, rgb30;

typedef int8		**mhandle;

 #if defined(HAVE_OS) && defined(WIN32)
  #include <windows.h>
 #endif

 #ifdef __QUICKDRAW__
  #define HAVE_OS
 #endif
 #if TARGET_OS_MAC
typedef struct PixMap		*platform_hpixmap;
typedef struct ColorSpec	platform_cspec;
typedef struct ColorTable	**platform_ctab, *platform_lpal;
 #elif defined(WINUSERAPI)
  #define HAVE_OS
typedef HBITMAP			platform_hpixmap;
typedef PALETTEENTRY		platform_cspec;
typedef LOGPALETTE		*platform_lpal;
typedef HPALETTE		platform_ctab;
 #else
  #undef HAVE_OS
 #endif

 #if TARGET_API_MAC_CARBON
  typedef struct PixMap		**platform_pixmap;
  typedef struct OpaqueGrafPtr	*platform_grafport;
  typedef struct GDevice	**platform_gdevice;
  typedef struct OpaqueWindowPtr *platform_window;
  typedef struct OpaqueDialogPtr *platform_dialog;
  typedef struct OpaqueMenuHandle *platform_menu;
  typedef struct OpaqueRgnHandle *platform_region;
 #elif TARGET_OS_MAC
  typedef struct PixMap		**platform_pixmap;
  typedef struct CGrafPort	*platform_grafport;
  typedef struct GDevice	**platform_gdevice;
  typedef struct GrafPort	*platform_window, *platform_dialog;
  typedef struct MenuInfo	**platform_menu;
  typedef struct MacRegion	**platform_region;
 #else
  typedef struct pixMap		*platform_pixmap;
  typedef struct grafPort	*platform_grafport;
  typedef struct windowRecord	*platform_dialog;
  #ifdef WINUSERAPI
   typedef HDC			platform_gdevice;
   typedef HWND			platform_window;
   typedef HMENU		platform_menu;
   typedef HRGN			platform_region;
  #endif
 #endif

typedef void (*noparam_proc)(void);

#if defined(mac) && !TARGET_OS_MAC
 #include <pshpack2.h>
#endif
typedef struct ARGB32
{
	uint8		a, r, g, b;
} ARGB32;

typedef struct rgb48/*(6)*/
{
	uint16		red, green, blue;
} rgb48;

typedef struct cSpec
{
	uint8		flags, value;
	rgb48		rgb;
} cSpec, rgb_color_value;

typedef struct cTab64
{
	int32		seed; /* matching ID */
	uint16		flags, count;
	cSpec		colors[1];
} cTab64;

/* this needs to match QD's Rect */
typedef struct rect16
{
	int16		top, left, bottom, right;
} rect16, rectangle;

typedef struct rect32
{
	int32		top, left, bottom, right;
} rect32;
typedef struct pt2d16
{
	int16		x, y;
} pt2d16;

typedef struct pt2dq
{
	ifixed		x, y;
} pt2dq;

#define RECTANGLE_WIDTH(r)		((r)->right-(r)->left)
#define RECTANGLE_HEIGHT(r)		((r)->bottom-(r)->top)

typedef struct textspec
{
	int16		size;
	uint8		style, special;
#ifdef USE_WINDOWS_FONTS
	LOGFONT		lf;
	HFONT		hfont;
#else
	int16		fontID;
#endif
} textspec;

typedef struct fontspec/*(80+)*/
{
	uint8		name[66];
	textspec	face;
	/* accumulative: ascent, ascent+leading, ascent+leading+descent */
	uint16		ascent, height, spacing;
	uint16		maximum_width;
} fontspec;

typedef long (TrailProcPtr)();

/* ------- constants */

#define INT_NO_VALUE			((int)0x80000000)

#define SHORT_MAX			0x7FFF
#define SHORT_MIN			(~SHORT_MAX)
#define LONG_MAX			0x7FFFFFFF
#define LONG_MIN			(~LONG_MAX)
#if LONG_LONG
# define INT64_MAX			9223372036854775807LL
# define INT64_MIN			((int64)-9223372036854775808.)
#else
# define INT64_MAX			9223372036854775807.0
# define INT64_MIN			(-9223372036854775808.0)
# ifndef env68k
#  error Either long long or env68k must be defined.
# endif
#endif

#define NONE				(-1)

#define iOK				1
#define iCANCEL				2

#define KILO				(1<<10)
#define MEG				(1<<20)

#define FIXED_FRACTIONAL_BITS		16
#define FIXED_ONE			0x10000

#define PIXEL15_MAX_COMPONENT		31
#define PIXEL24_MAX_COMPONENT		255

enum
{ /* system_colors */
	_system_window_highlight, /* light gray-blue */
	_system_gray_blue,
	_system_gray15,
	_system_gray33,
	_system_gray47,
	_system_gray53,
	_system_gray67,
	_system_gray73,
	_system_gray87,
	_system_gray93,
	_system_alert_frame_color,
	_system_alert_content_color,
	_system_alert_tl_color, /* top-left of frame */
	_system_alert_br_color, /* bottom-right of frame */

	NUMBER_OF_SYSTEM_COLORS
};

enum
{ /* chromo colors */
	_rgb_black,
	_rgb_blue,
	_rgb_green,
	_rgb_cyan,
	_rgb_red,
	_rgb_magenta,
	_rgb_yellow,
	_rgb_white
};

/* ------- macros */

#define INTEGER_TO_FIXED(x)		((x)<<16)
#define FIXED_INTEGRAL_PART(x)		((x)>>16) //was FIXED_INTEGERAL_PART

#define _PIXEL15(r,g,b) \
	(pixel15)((uint32)(r)<<10&0x7C00|((uint32)(g)<<5&0x3E0)|((uint32)(b)&31))
#define _PIXEL24(r,g,b) \
	(pixel24)((uint32)(uint8)(r)<<16|(uint32)(uint8)(g)<<8|(uint8)(b))
#define _PIXEL30(r,g,b) \
	(pixel32)(((uint32)(r)<<20&0x3FF00000)|((uint32)(g)<<10&0xFFC00)|((uint32)(b)&1023))
#define _PIXEL32(r,g,b,a)		(pixel32)((uint32)(a)<<24 \
	|((uint32)(r)<<16&0xFF0000)|((uint32)(g)<<8&0xFF00)|((uint32)(b)&255))

#define ALPHA15(x)			((pixel15)(x)>>15)
#define RED15(x)			(31&(x)>>10)
#define GREEN15(x)			(31&(x)>>5)
#define BLUE15(x)			(31&(x))

#define ALPHA24(x)			((pixel32)(x)>>24)
#define RED24(x)			(uint8)((pixel32)(x)>>16)
#define GREEN24(x)			(uint8)((pixel32)(x)>>8)
#define BLUE24(x)			(uint8)(x)

#ifdef env68k
# pragma parameter __D0 get_a0()
  extern int32 get_a0(void) = 0x2008;
# pragma parameter __D0 get_a1()
  extern int32 get_a1(void) = 0x2009;
# pragma parameter __D0 get_a5()
  extern int32 get_a5(void) = 0x200D;

/* very dangerous... */
# pragma parameter __D0 set_a5(__D1)
  extern int32 set_a5(int32) = {0x200D, 0x2A41};
#endif

/* ------- globals */

extern char		temporary[512];
extern const rgb48	chromo_colors[8], system_colors[NUMBER_OF_SYSTEM_COLORS];
#define rgb_black chromo_colors[_rgb_black]
#define rgb_white chromo_colors[_rgb_white]

#ifdef WINUSERAPI
extern HBITMAP		world_screen_dib;
extern HPALETTE		world_screen_pal;
#else
extern platform_grafport	world_port;
#endif
#ifdef HAVE_OS
extern platform_gdevice		world_device;
extern platform_window		world_screen_window;
#endif

extern const uint8	Mac8bppRGB12[2*256];
extern const uint8	Mac4bppRGB24[3*16];
extern const uint8	Mac2bppRGB24[3*4];

/* ------- debugging (as mycseries is internalized) */

void initialize_debugger(boolean useSys);

void _debugMsg(const char *msg,
	const char *src,
	int lin);

/* to save on code space, the level is now encoded in the line parameter (over a billion lines?) */
/* the expression is calculated */
#ifndef __source__
 #define __source__			__func__
#endif
#if DEBUG
 #define warn(x)			do{if(!(x)) _debugMsg(#x,__source__,__LINE__);}while(0)
 #define vwarn(x,y)			do{if(!(x)) _debugMsg(y,__source__,__LINE__);}while(0)
#else
 #define warn(x)			(void)(!(x))
 #define vwarn(x,y)			(void)(!(x))
#endif
/* assertion */
#ifndef assert
# if DEBUG
#  define assert(x)			do{if(!(x)) _debugMsg(#x,__source__,__LINE__|1<<30);}while(0)
# else
#  define assert(x)			(void)(!(x))
# endif
# if DEBUG
#  define vassert(x,y)			do{if(!(x)) _debugMsg(y,__source__,__LINE__|1<<30);}while(0)
# else
#  define vassert(x,y)			(void)(!(x))
# endif
/* pause program */
# if DEBUG
#  define pause()			_debugMsg(0,__source__,__LINE__|2<<30)
# else
#  define pause()
# endif
# if DEBUG
#  define vpause(x)			_debugMsg(x,__source__,__LINE__|2<<30)
# else
#  define vpause(x)
# endif
/* halt program (something's corrupt) - encoded regardless of DEBUG */
# define halt()				_debugMsg(0,__source__,__LINE__|3<<30)
# define vhalt(x)			_debugMsg(x,__source__,__LINE__|3<<30)
#endif

/* ------- memory */

#define free_and_zero(x)		do{free(x); x=0;}while(0)
#define assert_free_and_zero(x)		do{assert((x)!=0); free(x); x=0;}while(0)

/* be aware that 'buffer_ref' is reference to pointer */
void *safe_realloc(void **buffer_ref,
	uint32 new_length);

/* ------- slots and entries */

#define SET_FLAG(f,b,v)			(void)((v)?((f)|=1L<<b):((f)&=~(1L<<b)))

/* these are used for anything else that has to be created by the active engine;
  e.g., objects, lights, liquids, etc. */
#define SLOT_IS_USED(o)			((o)->flags&(uint16)0x8000)
#define SLOT_IS_FREE(o)			(!SLOT_IS_USED(o))
#define MARK_SLOT_AS_FREE(o)		(void)((o)->flags&=(uint16)~0x8000)
#define MARK_SLOT_AS_USED(o)		(void)((o)->flags|=(uint16)0x8000)

extern char _pseu[]; /* free slot error */
extern char _poob[], _pioob[]; /* pointer-out-of-bounds error */

extern int _prev_entry_index, _prev_slot_index;

#define default_pointer(t,s)		(t*)((int)0&dprintf(_poob,s))
#define default_npointer(t,s,i)		(t*)((int)0&dprintf(_pioob,s,i))
#define default_ipointer(t,s,i)		((i==NONE?(t*)0:(t*)((int)0&dprintf(_pioob,s,i))))
#define default_upointer(t,s,i)		(t*)((int)0&dprintf(_pseu,s,i))

/* default type, default type string, array pointer, total count, index */
#define get_entry_data(t,s,p,c,i)	((unsigned)(_prev_slot_index=i)>=(c) ? \
	default_ipointer(t,s,_prev_slot_index):_prev_slot_index+(p))
#define get_slot_data(t,s,p,c,i)	((unsigned)(_prev_slot_index=i)>=(c) ? \
	default_ipointer(t,s,_prev_slot_index):(SLOT_IS_FREE(_prev_slot_index+(p)) ? \
	default_upointer(t,s,_prev_slot_index):_prev_slot_index+(p)))

/* ------- prototypes */

/* math */

/* these two are only meant for rendering and don't call for overflow handling */
#ifdef env68k
# pragma parameter __D0 UMulDiv(__D0, __D1, __D2)
  extern uint32 UMulDiv(uint32, uint32, uint32) = {
/*	MULU.L       D1,D1:D0	*/	0x4C01, 0x401,
/*	DIVU.L       D2,D1:D0	*/	0x4C42, 0x401
  };
# pragma parameter __D0 NMulDiv(__D0, __D1, __D2)
  extern int32 NMulDiv(int32, int32, int32) = {
/*	MULS.L       D1,D1:D0	*/	0x4C01, 0xC01,
/*	DIVS.L       D2,D1:D0	*/	0x4C42, 0xC01
  };
#else
# define UMulDiv(x,n,d)			(uint32)(((long long)(uint32)(x)*(uint32)(n))/(uint32)(d))
# define NMulDiv(x,n,d)			(int32)(((long long)(int32)(x)*(int32)(n))/(int32)(d))
#endif

/* ---- time */

#define SMALL_TICK_TIME			16625	/* in microseconds */

#if TARGET_OS_MAC
 #if __MACH__
  #undef SMALL_TICK_TIME
  #define SMALL_TICK_TIME		10000
 #endif
EXTERN_API(UInt32) TickCount(void) ONEWORDINLINE(0xA975);
#else
 uint32 TickCount(void);
#endif

#ifdef TARGET_OS_MAC
 #define asyncUncompleted		1
 #if __MACH__
  #define SYSTEM_TICKS_PER_SECOND	100
 #else
  #define SYSTEM_TICKS_PER_SECOND	60
 #endif
 #define NATIVE_TICKS_PER_SECOND	SYSTEM_TICKS_PER_SECOND
#else
 #define SYSTEM_TICKS_PER_SECOND	60
 #define NATIVE_TICKS_PER_SECOND	1000
#endif

#if !TARGET_OS_MAC
typedef uint64 UnsignedWide;
void Microseconds(UnsignedWide *);
#endif

/* ---- memory string section: remap, count, AND-mask-count, first AND-mask */

void memrem(void *p,
	long c,
	const unsigned char *t);
uint32 memcnt(const void*,
	int v,
	uint32 z);
uint32 memcntbit(const void*,
	int mask,
	uint32 z);
void *memchrbit(const void*,
	int mask,
	uint32 z);

/* ---- text string section */

uint8 *pstrcpy(void*,
	const void*);

/* copies C source to Pascal destination */
unsigned char *cpstrcpy(void *d,
	const void *s,
	unsigned short maxlength);

/* like GetIndString, but the index is zero-based */
unsigned char *getpstr(void *d,
	short strlistid,
	int x);
int getcstr(char *d,
	short strlistid,
	int x);
int countstrlist(short strlistid);

char *csprintf(char*,
	const char *form,
	...);
uint8 *psprintf(void*,
	const char *form,
	...);
int dprintf(const char *form,
	...);

/* ---- memory allocation section */

void *tmalloc(uint32 size);

mhandle new_mhandle(long z,
	boolean lock);

int dispose_mhandle(mhandle h);

long get_mhandle_size(mhandle h); /* error code if negative */

int set_mhandle_size(mhandle h,
	long z);
/* get/set_mhandle_state no longer available; use get_mhandle_lock instead */
/* purge-able should always be off */
int set_mhandle_lock(mhandle h,
	boolean lock);
int get_mhandle_lock(mhandle h,
	boolean *lock);
#define lock_mhandle(h)			set_mhandle_lock(h,1)
#define unlock_mhandle(h)		set_mhandle_lock(h,0)

int move_mhandle_high(mhandle h);

int memory_error(void);
#ifdef WINUSERAPI
long FreeMem(void);
#define TempFreeMem FreeMem
#endif

mhandle getresource(uint32 type,
	const uint8 *name, /* can be NULL (use ID) */
	short ID);

/* ---- graphics and devices section */

#if TARGET_OS_MAC && !TARGET_API_MAC_CARBON
const uint8 *GetDCtlName(int16 refNum);
#endif
#ifdef HAVE_OS
int GetSlotFromGDevice(platform_gdevice targetGD);

int get_window_frame(platform_window window,
	rectangle *screen_bounds);
int invalidate_window_rect(platform_window w,
	const rectangle *r);
int validate_window_rect(platform_window w,
	const rectangle *r);

void _get_region_bounds(platform_region r,
	rectangle*);
#endif
void _get_port_bounds(platform_grafport port,
	rectangle *destination);
void *_get_port_pixmap(platform_grafport port);

uint8 *_get_gray_pattern(uint8 out_pat[8]); /* 8x8 1 bit */

void ctMakeGrays(cSpec *d, /* must be valid */
	int c); /* negative for reverse, >256 for 'direct' */
const uint8 *parseColorsBE(cSpec *d,
	const uint8 *s,
	int c,
	int z,
	uint8 f);
platform_pixmap alloc_image(short depth,
	short width,
	short height,
	platform_grafport *outPort); /* can be NULL */
platform_pixmap renderQDPict(const uint8 *start,
	uint32 size);

/*
 expandRGB24/expandRGB12
	These expand compacted tables into a cSpec table.
	expandRGB24 takes 3 unaligned bytes each.
	expandRGB12 takes 2 bytes each in the form: 0x0r,0xgb.
*/
void expandRGB24(const uint8 *s,
	cSpec *d,
	int count,
	int startIx);
void expandRGB12(const uint8 *s,
	cSpec *d,
	int count,
	int startIx);

#if TARGET_OS_MAC
int fill_in_raw_pixmap(struct PixMap*,
	const rectangle *bounds,
	short depth, /* allowed */
	int row_size);
int default_clut(struct ColorTable **cth,
	short depth);
#else
int32 GetCTSeed(void);
#endif

#ifdef HAVE_OS
 #if !TARGET_OS_MAC
int wSetVideoMode(int depth,
	int width,
	int height,
	int initpos,
	int screen_fs);

void SetEntries(short first,
	short count, /* zero-based (subract one) */
	const cSpec*); /* must be valid */

  #ifdef WINUSERAPI
/* note that this does not set rgbReserved */
void setQuadColors(RGBQUAD *d, /* must be valid */
	const cSpec *s, /* must be valid */
	int count);
/* all parameters must be valid */
int setDevicePalette(HDC hdc,
	HPALETTE *hpal,
	const cSpec *cs,
	short o,
	short c,
	boolean animate);
int syncDIBPal(HDC hdc,
	HBITMAP dib,
	const cSpec *cs,
	short o,
	short c);

int wRegisterDev(HINSTANCE hInstance,
	HICON icon,
	HCURSOR curs,
	HBRUSH bgBrush,
	TCHAR *name);

void wResizeNative(HWND hwnd,
	int w,
	int h,
	int screen_fs);

void SetWindowTitle(HWND hwnd,
	const uint8 *title);

int printOSMessage(int32 err,
	const char *caller,
	const char *defaultMsg);
  #endif
 #endif

 /* returns the platform-specific error code */
int direct_set_colors(short first,
	short count, /* zero-based (subract one) */
	platform_gdevice gd,
	const cSpec *cs); /* must be valid */
#endif

void update_screen_rect(int x,
	int y,
	int w,
	int h);

int global_to_local_pt(pt2d16 *loc);
int get_mouse_loc(int16 *x,
	int16 *y);
int set_mouse_cursor(int ID,
	boolean color);
void show_cursor(void);
void hide_cursor(void);

boolean mouse_still_down(void);

void stop_interface_fade(void);

#ifdef HAVE_OS
void SetMenuItemEnable(platform_menu m,
	uint16 i,
	boolean a);
#endif

/* ---- dialogs section */

int extract_int_from_text_item(platform_dialog d,
	int i);
void insert_int_into_text_item(platform_dialog d,
	int i,
	int v);
void animate_dialog_button(platform_dialog d,
	int i);

/* ---- text section */

int update_fontspec(fontspec *spec); /* sets up fontID, height, spacing... */
void get_port_font(textspec *spec);
void set_port_font(const textspec *spec);

/* system section */

int cs_initialize(const void*);

int atexittoshell(noparam_proc,
	int flags);

void global_idle_proc(void);

int OSPollKeyMouse(boolean down);

int wait_for_click_or_keypress(uint32 maxMilliseconds,
	boolean waitUp);

enum
{ /* alert types */
	fatalError,
	infoError
};
void alert_user(int alertType,
	short strID,
	int index,
	short err);

void kill_screen_saver(void);

#endif /*!defined(rez) && !defined(derez)*/

#define __MY_CSERIES_H
#endif
