;
;_sndmixer.asm
;
; Created: 2014.03.25
; Revised: 2014.03.25
;
; You can redistribute this file and/or modify it under the
; terms of version 2 of the GNU General Public License as
; published by the Free Software Foundation.  You should have
; received a copy of the license along with this file.
;
; This file is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty
; of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
; See LICENSE.txt more details.

	.486
	.code

	option fieldalign:2

sndMixerFrame	struct
mixerRtn	ptr ?	;ourself
cmpSamples	ptr ?
dcmpBuf		ptr ?

sndFormat	struct
codec		dd ?
rate		dd ?
rateFrac	dd ?
chanCount	db ?
type		db ?
depth		db ?
mSampleSize	db ?
frameCount	sdword ?
frameSize	sdword ?
packSize	dw ?
blockSize	dw ?
maxRead		dd ?
totalCount	dq ?
variables	sword 16 dup(?)
	ends

rateMul		dd ?
LRAmp		dd ?
pos		dd ?
cnvRate		dd ?
cnvFrc		dw ?
sndMixerFrame	ends

;int n(int32*d, const void*p, sndMixerFrame*m, int rem)
mixRoutine	equ	uses edi esi ebx,d:dword ptr, s:ptr, m:ptr, c:sdword

rv		equ	d	;reused
rl		equ	bx

startRateCnv	macro
	mov	esi,s	;const t*s=p;
	mov	edi,d
	mov	eax,m	;uint32 rt=((uint16*)&m->cnvRate)[!BIG_ENDIAN];
	movzx	edx,word ptr [eax+sndMixerFrame.cnvRate+2]
	mov	rt,edx
	mov	dx,word ptr [eax+sndMixerFrame.cnvRate]
	mov	bx,[eax+sndMixerFrame.cnvFrc]
	mov	rf,dx
	mov	edx,[eax+sndMixerFrame.LRAmp]
	endm
endRateCnv	macro
	mov	eax,m ;m->pos=(const uint8*)s-m->dcmpBuf, m->cnvFrc=rf;
	mov	edx,[eax+sndMixerFrame.dcmpBuf]
	sub	esi,edx
	mov	dword ptr [eax+sndMixerFrame.pos],esi
	mov	[eax+sndMixerFrame.cnvFrc],bx
	endm
lerp		macro a,b,m
	movsx	eax,a
	movsx	edx,b
	sub	edx,eax
	imul	edx,m
	sar	edx,15
	add	edx,eax
	endm
ivol		macro m
	imul	edx,m
	sar	edx,8
	endm

rateCnvIntrp2	proc	mixRoutine
	local	rf:word,rt:dword,lv:dword
	startRateCnv
	cmp	edx,01000100h
	jne	vo

oc:	movzx	ecx,rl
	shr	ecx,1
	lerp	word ptr [esi],word ptr [esi+4],ecx
	add	[edi],edx
	lerp	word ptr [esi+2],word ptr [esi+6],ecx
	add	[edi+4],edx
	xor	eax,eax
	add	rl,rf
	adc	eax,rt
	lea	esi,[esi+eax*4]
	add	edi,8
	dec	c
	jnz	oc
	jmp	eo

vo:	movsx	eax,dx ;lv=m->LRAmp, rv=(int16)lv; lv>>=16;
	mov	rv,eax
	sar	edx,16
	mov	lv,edx
vc:	movzx	ecx,rl
	shr	ecx,1
	lerp	word ptr [esi],word ptr [esi+4],ecx
	ivol	lv
	add	[edi],edx
	lerp	word ptr [esi+2],word ptr [esi+6],ecx
	ivol	rv
	add	[edi+4],edx
	xor	eax,eax
	add	rl,rf
	adc	eax,rt
	lea	esi,[esi+eax*4]
	add	edi,8
	dec	c
	jnz	vc

eo:	endRateCnv
rateCnvIntrp2	endp

rateCnvIntrp2m	proc	mixRoutine
	local	rf:word,rt:dword,lv:dword
	startRateCnv
	cmp	edx,01000100h
	jne	vo

oc:	movzx	ecx,rl
	shr	ecx,1
	lerp	word ptr [esi],word ptr [esi+4],ecx
	mov	lv,edx
	lerp	word ptr [esi+2],word ptr [esi+6],ecx
	add	edx,lv
	sar	edx,1
	add	[edi],edx
	add	[edi+4],edx
	xor	eax,eax
	add	rl,rf
	adc	eax,rt
	lea	esi,[esi+eax*4]
	add	edi,8
	dec	c
	jnz	oc
	jmp	eo

vo:	movsx	eax,dx ;lv=m->LRAmp, rv=(int16)lv; lv>>=16;
	mov	rv,eax
	sar	edx,16
	mov	lv,edx
vc:	movzx	ecx,rl
	shr	ecx,1
	lerp	word ptr [esi],word ptr [esi+4],ecx
	imul	edx,lv
	mov	s,edx
	lerp	word ptr [esi+2],word ptr [esi+6],ecx
	imul	edx,rv
	add	edx,s
	sar	edx,9
	add	[edi],edx
	add	[edi+4],edx
	xor	eax,eax
	add	rl,rf
	adc	eax,rt
	lea	esi,[esi+eax*4]
	add	edi,8
	dec	c
	jnz	vc

eo:	endRateCnv
rateCnvIntrp2m	endp
